<?php
$className = 'RBSPayment';
$paymentName = 'Оплата картой банка (RBSPayment)';
include 'standalone.php';
$objectTypesCollection = umiObjectTypesCollection::getInstance();
$internalTypeId = $objectTypesCollection->getTypeIdByGUID('emarket-paymenttype');
$sel = new selector('objects');
$sel->types('object-type')->id($internalTypeId);
$sel->where('class_name')->equals($className);
$sel->limit(0, 1);
$bAdd = $sel->length() == 0;
$fieldTypesCollection = umiFieldTypesCollection::getInstance();
$typeBoolean = $fieldTypesCollection->getFieldTypeByDataType('boolean');
$typeString = $fieldTypesCollection->getFieldTypeByDataType('string');
$typeInt = $fieldTypesCollection->getFieldTypeByDataType('int');
if ($bAdd) {
$objectsCollection = umiObjectsCollection::getInstance();
$parentTypeId = $objectTypesCollection->getTypeIdByGUID('emarket-payment');
$typeId = $objectTypesCollection->addType($parentTypeId, $paymentName);
$objectType = $objectTypesCollection->getType($typeId);
$groupdId = $objectType->addFieldsGroup('settings', 'Параметры', true, true);
$group = $objectType->getFieldsGroupByName('settings');
$fieldsCollection = umiFieldsCollection::getInstance();
$fieldTypesCollection = umiFieldTypesCollection::getInstance();
$typeBoolean = $fieldTypesCollection->getFieldTypeByDataType('boolean')->getId();
$typeString = $fieldTypesCollection->getFieldTypeByDataType('string')->getId();
$typeInt = $fieldTypesCollection->getFieldTypeByDataType('int')->getId();
$typeSelect = $fieldTypesCollection->getFieldTypeByDataType('relation')->getId();
$idRBSTestMode = $objectTypesCollection->addType(1, 'rbs-testMode');
$idRBSTwoStage = $objectTypesCollection->addType(1, 'rbs-twoStage');
$idRBSLogging = $objectTypesCollection->addType(1, 'rbs-logging');
$idRBSTaxSystem = $objectTypesCollection->addType(1, 'rbs-taxType');
$idRBSFFDVersion = $objectTypesCollection->addType(1, 'rbs-FFDVersion');
$idRBSPaymentMethod = $objectTypesCollection->addType(1, 'rbs-paymentMethod');
$idRBSPaymentObject = $objectTypesCollection->addType(1, 'rbs-paymentObject');
$idRBSSendOrder = $objectTypesCollection->addType(1, 'rbs-sendOrder');
$idRBSVerifySLLCert = $objectTypesCollection->addType(1, 'rbs-verifySLLCert');

$optionTaxType = array(
'0' => 'Общая (0)',
'1' => 'Упрощённая, доход (1)',
'2' => 'Упрощённая, доход минус расход (2)',
'3' => 'Eдиный налог на вменённый доход (3)',
'4' => 'Eдиный сельскохозяйственный налог (4)',
'5' => 'Патентная система налогообложения (5)',
);
$optionFFDVersion = array(
'v1_05' => 'v1.05',
'v1_2' => 'v1.2',
);
$optionPaymentMethod = array(
'1' => 'Полная предварительная оплата до момента передачи предмета расчёта (1)',
'2' => 'Частичная предварительная оплата до момента передачи предмета расчёта (2)',
'3' => 'Аванс (3)',
'4' => 'Полная оплата в момент передачи предмета расчёта (4)',
'5' => 'Частичная оплата предмета расчёта в момент его передачи с последующей оплатой в кредит (5)',
'6' => 'Передача предмета расчёта без его оплаты в момент его передачи с последующей оплатой в кредит (6)',
'7' => 'Оплата предмета расчёта после его передачи с оплатой в кредит (7)',
);
$optionPaymentObject = array(
'1' => 'Товар (1)',
'2' => 'Подакцизный товар (2)',
'3' => 'Работа (3)',
'4' => 'Услуга (4)',
'5' => 'Ставка азартной игры (5)',
'7' => 'Лотерейный билет (7)',
'9' => 'Предоставление РИД (9)',
'10' => 'Платёж (10)',
'11' => 'Агентское вознаграждение (11)',
'12' => 'Составной предмет расчёта (12)',
'13' => 'Иной предмет расчёта (13)',
);
$objectsCollection = umiObjectsCollection::getInstance();

foreach ($optionTaxType as $key => $value) {
$objectsCollection->addObject($value, $idRBSTaxSystem);
}
foreach ($optionFFDVersion as $key => $value) {
$objectsCollection->addObject($value, $idRBSFFDVersion);
}
foreach ($optionPaymentMethod as $key => $value) {
$objectsCollection->addObject($value, $idRBSPaymentMethod);
}
foreach ($optionPaymentObject as $key => $value) {
$objectsCollection->addObject($value, $idRBSPaymentObject);
}
$fields = array(
'payment_type_id' => array(
'name' => 'Метод оплаты',
'type' => $typeSelect,
'guide_id' => $internalTypeId,
'required' => true,
),
'rbspayment_user_name' => array(
'name' => 'Логин',
'tip' => 'Предоставляется банком',
'type' => $typeString,
'required' => true,
),
'rbspayment_password' => array(
'name' => 'Пароль',
'tip' => 'Предоставляется банком',
'type' => $typeString,
'required' => true,
),
'rbspayment_test_mode' => array(
'name' => 'Тестовый режим работы модуля',
'type' => $typeBoolean,
'required' => true,
),
'rbspayment_two_stage' => array(
'name' => 'Двух стадийные платежи',
'type' => $typeBoolean,
'required' => true,
),
'rbspayment_send_order' => array(
'name' => 'Передавать данные корзины покупателя в платежный шлюз для формирования чека',
'type' => $typeBoolean,
'required' => true,
),
'rbspayment_tax_system' => array(
'name' => 'Система налогообложения',
'tip' => 'Укажите систему налогообложения (в случае предачи данных корзины покупателя)',
'type' => $typeSelect,
'guide_id' => $idRBSTaxSystem,
'required' => true,
),
'rbspayment_FFDVersion' => array(
'name' => 'Версия ФФД',
'type' => $typeSelect,
'guide_id' => $idRBSFFDVersion,
'required' => true,
),
'rbspayment_payment_methodType' => array(
'name' => 'Признак способа расчёта',
'tip' => 'Укажите признак способа расчёта (в случае предачи данных корзины покупателя)',
'type' => $typeSelect,
'guide_id' => $idRBSPaymentMethod,
'required' => true,
),
'rbspayment_payment_objectType' => array(
'name' => 'Признак предмета расчёта',
'tip' => 'Укажите признак предмета расчёта (в случае предачи данных корзины покупателя)',
'type' => $typeSelect,
'guide_id' => $idRBSPaymentObject,
'required' => true,
)
);
$field_ext = array(
'rbspayment_verify_SLL_cert' => array(
'name' => 'Проверять SLL сертификат',
'type' => $typeBoolean,
'required' => false,
)
);
if (file_exists($_SERVER['DOCUMENT_ROOT'] . "/cacert.cer")) {
$fields = array_merge($fields, $field_ext);
}

foreach ($fields as $code => $arField) {
$fieldId = $fieldsCollection->addField($code, $arField['name'], $arField['type']);
$field = $fieldsCollection->getField($fieldId);
$isRequired = isset($arField['required']) ? $arField['required'] : false;
if (isset($arField['guide_id'])) {
$field->setGuideId($arField['guide_id']);
}
$field->setIsRequired($isRequired);
$field->setIsInSearch(false);
$field->setIsInFilter(false);
$field->commit();
$group->attachField($fieldId);
}
$internalObjectId = $objectsCollection->addObject($paymentName, $internalTypeId);
$internalObject = $objectsCollection->getObject($internalObjectId);
$internalObject->setValue('class_name', $className); // имя класса для реализации
$internalObject->setValue('payment_type_id', $typeId);
$internalObject->setValue('payment_type_guid', 'emarket-payment-' . $typeId);
$internalObject->commit();
$objectType = $objectTypesCollection->getType($typeId);
$objectType->setGUID($internalObject->getValue('payment_type_guid'));
$objectType->commit();
echo 'Установка модуля успешно завершена. id #' . $typeId;
} else {
echo 'Способ оплаты с классом ' . $className . ' уже существует';
}
